diff --git a/apt-listbugs b/apt-listbugs
index 58d67cb..bed944f 100755
--- a/apt-listbugs
+++ b/apt-listbugs
@@ -289,7 +289,15 @@ when "apt"
   puts if $DEBUG
   puts "Pre-Install-Pkgs hook info:" if $DEBUG
   state=1
-  STDIN.each { |pkg|
+  apt_fifo_filename = "/var/run/apt-listbugs-hook"
+  begin
+      apt_fifo_fd = open(apt_fifo_filename, 'r')
+  rescue Errno::ENOENT
+        $stderr.puts sprintf(_("W: Cannot open %s"), apt_fifo_filename)
+        exit(1)
+  end
+
+  apt_fifo_fd.each { |pkg|
     pkg=pkg.rstrip
     case state
     when 1
@@ -353,6 +361,7 @@ when "apt"
       end
     end
   }
+  apt_fifo_fd.close
   puts if $DEBUG
 when "list", "rss"
   ARGV.each { |pkg|
